var pos = 0;
var oldpos = 0;
var mode = "setup";
var count = 0;
var results = [];
var firstPass = false;
var helpLoaded = false;

$(document).ready(function () {
    var instTitle = $('#instructiontitle');
    var winH = $(window).height();
    var topbarH = $('#topbar').height();
    var stickbatsH = $('#topstickbar').height() * 2;
    var insTitleH = instTitle.height();
    var mainH = $('#main').height();
    var totH = topbarH + stickbatsH + insTitleH + mainH;
    if (totH < winH) {
        instTitle.css('marginBottom', (winH - totH) / 2);
    }

    $("#dialog-message").dialog({
        modal: true,
        autoOpen: false,
        buttons: {
            Ok: function () {
                $(this).dialog("close");
            }
        }
    });

    var position = decodeURIComponent($.urlParam('pos'));
    var prevpos = decodeURIComponent($.urlParam('oldpos'));
    var mod = decodeURIComponent($.urlParam('mode'));
    var cnt = decodeURIComponent($.urlParam('count'));

    if (position != "null") {
        pos = position;
    }
    if (prevpos != "null") {
        oldpos = prevpos;
    }
    if (mod != "null") {
        mode = mod;
    }
    if (cnt != "null") {
        count = cnt;
    }

    if( position == "null" && prevpos == "null" && mod == "null" && cnt == "null")
    {
        firstPass = true;
    }

    for (var residx = 0; residx < count; residx++) {
        var restempStr = decodeURIComponent($.urlParam('res' + residx.toString()));
        if (restempStr != "null") {
            results.push(restempStr);
        }
    }

    positionTarget(oldpos);
    $('#positiontarget').addClass("testtrans");
    positionTarget(pos);
});

$('.LEDButton').click(function () {
    $('.LEDButton').addClass('LEDButtonOff');
    $(this).removeClass('LEDButtonOff');

    $('.SevenSeg').addClass('SevenSegOff');
    $('div.LEDButton').each(function (index) {
        if (!$(this).hasClass('LEDButtonOff')) {
            var segsToLight = SevenSegTable[index];
            for( var i = 0; i < segsToLight.length; i++ )
            {
                $('#SevenSegCell').find("#" + segsToLight[i]).removeClass("SevenSegOff");
            }
        }
    });
});

$('#LEDClearButton').click(function () {
    $('.LEDButton').addClass('LEDButtonOff');
    $('.SevenSeg').addClass('SevenSegOff');
});

$('#nextbutton').click(function () {
    var destination = "";
    var ledlist = "";

    $('div.LEDButton').each(function (index) {
        if (!$(this).hasClass('LEDButtonOff')) {
            index += 1;
            ledlist += index.toString();
        }
    });
    if (ledlist == "") {
        ledlist = "N";
    }
    else if (ledlist == "10") {
        ledlist = "0";
    }

    if (mode == "setup") {
        var reference = "";
        var selectedEntry;
        if (pos < validSteps.length) {
            var ledsForPos = validSteps[pos].validleds;
            for (var i = 0; i < ledsForPos.length; i++) {
                if (ledsForPos[i].sel == ledlist) {
                    selectedEntry = ledsForPos[i];
                    reference = selectedEntry.ref;
                    break;
                }
            }
        }
        else {
            alert("ERROR: Position out of range, try reinstalling ActivManager or contact Promethean Support");
            return;
        }

        if (reference != "") {
            switch (reference) {
                case "E":
                    //Go to error page
                    switch (selectedEntry.type) {
                        case "illegal":
                            destination = "toowide.html";
                            break;
                        case "notflat":
                            destination = "notflat.html";
                            break;
                        case "space5":
                            destination = "spacer.html?add=5";
                            break;
                        case "space10":
                            destination = "spacer.html?add=10";
                            break;
                    }
                    break;

                case "C":
                    //Go to Check mode
                    destination = "leds.html?pos=" + upperCheckSeq[0] + "&mode=ucheck&oldpos=" + pos.toString() ;
                    break;

                case "OK":
                    //Go to next LED page
                    destination = "leds.html?pos=" + selectedEntry.pos + "&oldpos=" + pos.toString();
                    break;

                default:
                    //Go to action page
                    oldpos = pos;
                    if( selectedEntry.pos != null ) {
                        pos = selectedEntry.pos;
                    }
                    destination = "action.html?pos=" + pos.toString() + "&ref=" + reference + "&oldpos=" + oldpos.toString();
                    break;
            }

        }
        else {
            alert("LED combination not found, try reinstalling ActivManager or contact Promethean Support");
            //$( "#dialog-message" ).dialog('open');
        }
    }
    else {
        // mode == check
        console.log("check mode");
        if( ledlist == "N" )
        {
            //Error
            //alert("You must select a number at this step. Check that your stick is still on.")
            $( "#dialog-message" ).dialog('open');
        }
        else {
            if (mode == "ucheck") {
                count++;
                if (count < upperCheckSeq.length) {
                    destination = "leds.html?mode=ucheck&pos=" + upperCheckSeq[count] + "&count=" + count.toString() + "&oldpos=" + pos.toString();
                }
                else {
                    destination = "action.html?mode=ucheck&oldpos=" + pos.toString() + "&prog=" + progress.toString();
                }
            }
            else if (mode == "mcheck") {
                count++;
                if (count < midCheckSeq.length) {
                    destination = "leds.html?mode=mcheck&pos=" + midCheckSeq[count] + "&count=" + count.toString() + "&oldpos=" + pos.toString();
                }
                else {
                    destination = "action.html?mode=mcheck&oldpos=" + pos.toString() + "&prog=" + progress.toString();
                }
            }
            else if (mode == "lcheck") {
                count++;
                if (count < lowerCheckSeq.length) {
                    destination = "leds.html?mode=lcheck&pos=" + lowerCheckSeq[count] + "&count=" + count.toString() + "&oldpos=" + pos.toString();
                }
                else {
                    destination = "action.html?mode=lcheck&oldpos=" + pos.toString() + "&prog=" + progress.toString();
                }
            }
            results.push(ledlist);
            for (var j = 0; j < results.length; j++) {
                destination += "&res" + j.toString() + "=" + results[j];
            }
        }
    }

    if (destination == "") {
        console.log("No destination set");
    }
    else {
        window.location.href = destination;
    }

});


$('#backbutton').click(function () {
    if( !firstPass ) {
        console.log("Prev Click");
        window.history.back();
    }
    else {
        //Special case to go back to end of animation
        destination = "index.html?skip=1";
        window.location.href = destination;
    }
});

$('#helpbutton').click(function() {
    $('#modalBackground').toggle();
    $('#helpFrame').toggleClass("helpHidden");

    var fileName;
    if( mode == "setup" ) {
        fileName = "help/ledshelp.html";
    }
    else {
        fileName = "help/checkslidehelp.html";
    }

    if( !helpLoaded) {
        helpLoaded = true;
        $.get(fileName, function (data) {
            $('#helpContents').html(data);

            $(document).on('click', '.helpQuestion', function () {
                accordian($(this));
            });
        });
    }
});
