var pos = 0;
var oldpos = 0;
var mode = "setup";
var reference = "";
var results = [];
var destination = "";
var prog = 0;
var slideIndex = -1;
var helpLoaded = false;
var slideobj;

$(document).ready(function() {
    var instTitle = $('#instructiontitle');
    var winH = $(window).height();
    var topbarH = $('#topbar').height();
    var stickbatsH = $('#topstickbar').height() * 2;
    var insTitleH = instTitle.height();
    var mainH = $('#main').height();
    var totH = topbarH + stickbatsH + insTitleH + mainH;
    if( totH < winH )
    {
        instTitle.css('marginBottom', (winH - totH) / 2);
    }

    var position = decodeURIComponent($.urlParam('pos'));
    var prevpos = decodeURIComponent($.urlParam('oldpos'));
    var ref = decodeURIComponent($.urlParam('ref'));
    var mod = decodeURIComponent($.urlParam('mode'));
    var p = decodeURIComponent($.urlParam('prog'));

    if (position != "null") {
        pos = position;
    }
    if (prevpos != "null" ) {
        oldpos = prevpos;
    }
    if (ref != "null" ) {
        reference = ref;
    }
    if( mod != "null" ) {
        mode = mod;
    }
    if( p != "null") {
        prog = p;
    }

    var count = 0;
    switch( mode )
    {
        case "ucheck":
            count = upperCheckSeq.length;
            break;

        case "mcheck":
            count = midCheckSeq.length;
            break;

        case "lcheck":
            count = lowerCheckSeq.length;
            break;
    }
    for( var residx = 0; residx < count; residx++ )
    {
        var restempStr = decodeURIComponent($.urlParam('res' + residx.toString()));
        if( restempStr != "null" )
        {
            results.push(restempStr);
        }
    }

    positionTarget(oldpos);
    $('#positiontarget').addClass("testtrans");

    //Look up reference in table
    if( reference != "" ) {

        positionTarget(pos);

        if( pos == 0 ) {
//        $('#prevbutton').hide();
        }

        var found = false;
        for( var i = 0; i < slideInfo.length; i++ ) {
            if( slideInfo[i].ref == reference ) {
                found = true;
                var slideData = slideInfo[i];
                slideIndex = i;
                updatePage( slideData );
                destination = buildDestination(slideData);
                break;
            }
        }
    }
    else if ( mode != "setup") {
        checkResults();
    }
    else {
        alert("Page loaded without reference set");
    }

    if( prog > 0 )
    {
        $( "#progressbar" ).progressbar({
            value: Number(prog)
        });
    }

});

function updatePage( slideData )
{
    $('#toptext').html(slideData.toptext);
    $('#lowertext').html(slideData.lowertext);
    var topImgPath = "img/steps/" + slideData.topimg;
    $.get(topImgPath).done( function() {
        $('#actionimg').html("<img src='" + topImgPath + "' id='actionimgimg'>");
    }).fail(function() {
        $('#actionimg').html("<p>Det finns ingen bild för den här kombinationen av LED-indikatorer</p>");
    });
    var lowerImgPath = "img/steps/" + slideData.lowerimg;
    $.get(lowerImgPath).done( function() {
        $('#resultimg').html("<img src='" + lowerImgPath + "' id='resultimgimg'>");
    }).fail(function() {
        $('#resultimg').html("<p>Det finns ingen bild för den här kombinationen av LED-indikatorer</p>");
    });
}

function checkResults() {
    var count = 0;
    var toptext = $('#toptext');
    var lowertext = $('#lowertext');
    var collRes = collateResults();
    var Zeros = collRes[0];
    var Ones = collRes[1];
    var Twos = collRes[2];
    var Threes = collRes[3];
    var Fours = collRes[4];
    var Fives = collRes[5];
    var Sixes = collRes[6];
    var Sevens = collRes[7];
    var Eights = collRes[8];
    var Nines = collRes[9];
    var boardNotFlat = false;
    var goImmediately = false;
    var startagain = false;

    if( Zeros > 0 )
    {
        //Error
        destination = "toowide.html";
        goImmediately = true;
    }
    else {
        switch( mode )
        {
            case "ucheck":
                toptext.html("Kontrollerar den övre positionens resultat");
                lowertext.html("1: " + Ones + " 2: " + Twos + " 3: " + Threes
                    + " 4: " + Fours + " 5: " + Fives + " 6: " + Sixes
                    + " 7: " + Sevens + " 8: " + Eights);

                count = upperCheckSeq.length;
                if( Ones > 0 ) {
                    if( Ones == count ) {
                        //All LEDs are red
                        slideobj = {toptext: "Vrid det svarta hjulet moturs", topimg: "black-anti.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-3.png", help: "help/blackwheelhelp.html" };
                    }
                    else {
                        //Some LEDs are red
                        if( Sixes > 0 || Sevens > 0 || Eights > 0 || Nines > 0 ) {
                            //Board not flat
                            boardNotFlat = true;
                        }
                        else {
                            slideobj = {toptext: "Vrid det svarta hjulet moturs", topimg: "black-anti.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-2.png", help: "help/blackwheelhelp.html" };
                        }
                    }
                }
                else if ( Twos > 0 ) {
                    if( Twos == count ) {
                        //All LEDs are white
                        slideobj = {toptext: "Vrid det svarta hjulet moturs", topimg: "black-anti.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-3.png", help: "help/blackwheelhelp.html" };
                    }
                    else {
                        //Some LEDs are white
                        if( Sevens > 0 || Eights > 0 || Nines > 0 ) {
                            //Board not flat
                            boardNotFlat = true;
                        }
                        else {
                            //Go straight to checking lower positions
                            goImmediately = true;
                        }
                    }
                }
                else if ( Threes > 0 ) {
                    if( Threes == count ) {
                        //All LEDs are low Green
                        //Go straight to checking lower positions
                        goImmediately = true;
                    }
                    else {
                        //Some LEDs are low Green
                        if( Eights > 0 || Nines > 0 ) {
                            //Board not flat
                            boardNotFlat = true;
                        }
                        else if( Sevens > 0 ) {
                            slideobj = {toptext: "Vrid det svarta hjulet medurs", topimg: "black-clock.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-2.png", help: "help/blackwheelhelp.html" };
                        }
                        else
                        {
                            //Go straight to checking lower positions
                            goImmediately = true;
                        }
                    }
                }
                else if ( Fours > 0 ) {
                    if( Fours == count ) {
                        //All LEDs are high Green
                        slideobj = {toptext: "Vrid det svarta hjulet medurs", topimg: "black-clock.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-3.png", help: "help/blackwheelhelp.html" };
                    }
                    else {
                        //Some LEDs are high Green
                        if( Eights > 0 || Nines > 0 ) {
                            slideobj = {toptext: "Vrid det svarta hjulet medurs", topimg: "black-clock.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-2.png", help: "help/blackwheelhelp.html" };
                        }
                        else if( Sevens > 0 ) {
                            slideobj = {toptext: "Vrid det svarta hjulet medurs", topimg: "black-clock.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-3.png", help: "help/blackwheelhelp.html" };
                        }
                        else
                        {
                            slideobj = {toptext: "Vrid det svarta hjulet medurs", topimg: "black-clock.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-3.png", help: "help/blackwheelhelp.html" };
                        }
                    }
                }
                else {
                    //Must be all 5s or above
                    slideobj = {toptext: "Vrid det svarta hjulet medurs", topimg: "black-clock.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-3.png", help: "help/blackwheelhelp.html" };
                }

                if( slideobj != null )
                {
                    pos = findFirstPos(collRes);
                }

                if( boardNotFlat ) {
                    destination = "notflat.html";
                    goImmediately = true;
                }
                else {
                    destination = "leds.html?pos=" + lowerCheckSeq[0] + "&mode=lcheck&oldpos=" + pos;
                }
                break;

            case "mcheck":
                toptext.html("Kontrollerar den mellersta positionens resultat");
                lowertext.html("Red: " + collRes[0] + " White: " + collRes[1] + " Low Green: " + collRes[2]
                    + " High Green: " + collRes[3] + " Low Amber: " + collRes[4] + " High Amber: " + collRes[5]
                    + " Low Blue: " + collRes[6] + " High Blue: " + collRes[7]);
                count = midCheckSeq.length;
                if( Ones > 0 ) {
                    if( Ones == count ) {
                        //All LEDs are red
                        slideobj = {toptext: "Vrid det svarta hjulet moturs", topimg: "black-anti.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-2.png", help: "help/blackwheelhelp.html" };
                    }
                    else {
                        //Some LEDs are red
                        if( Sixes > 0 || Sevens > 0 || Eights > 0 || Nines > 0 ) {
                            //Board not flat
                            startagain = true;
                        }
                        else {
                            slideobj = {toptext: "Vrid det svarta hjulet moturs", topimg: "black-anti.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-2.png", help: "help/blackwheelhelp.html" };
                        }
                    }
                }
                else if ( Sevens > 0 || Eights > 0 || Nines > 0 ) {
                    //Board not flat
                    startagain = true;
                }
                else
                {
                    goImmediately = true;
                }

                if( startagain ) {
                    destination = "problem.html";
                    goImmediately = true;
                }
                else {
                    destination = "done.html";
                }
                break;

            case "lcheck":
                toptext.html("Kontrollerar den nedre positionens resultat");
                lowertext.html("Red: " + collRes[0] + " White: " + collRes[1] + " Low Green: " + collRes[2]
                    + " High Green: " + collRes[3] + " Low Amber: " + collRes[4] + " High Amber: " + collRes[5]
                    + " Low Blue: " + collRes[6] + " High Blue: " + collRes[7]);
                count = lowerCheckSeq.length;
                if( Ones > 0 ) {
                    if( Ones == count ) {
                        //All LEDs are red
                        slideobj = {toptext: "Vrid det silverfärgade hjulet medurs", topimg: "blue-clock.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-3.png", help: "help/silverwheelhelp.html" };
                    }
                    else {
                        //Some LEDs are red
                        if( Sixes > 0 || Sevens > 0 || Eights > 0 || Nines > 0 ) {
                            //Board not flat
                            boardNotFlat = true;
                        }
                        else {
                            slideobj = {toptext: "Vrid det silverfärgade hjulet medurs", topimg: "blue-clock.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-2.png", help: "help/silverwheelhelp.html" };
                        }
                    }
                }
                else if ( Twos > 0 ) {
                    if( Twos == count ) {
                        //All LEDs are white
                        slideobj = {toptext: "Vrid det silverfärgade hjulet medurs", topimg: "blue-clock.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-3.png", help: "help/silverwheelhelp.html" };
                    }
                    else {
                        //Some LEDs are white
                        if( Sevens > 0 || Eights > 0 || Nines > 0 ) {
                            //Board not flat
                            boardNotFlat = true;
                        }
                        else {
                            //Go straight to checking lower positions
                            goImmediately = true;
                        }
                    }
                }
                else if ( Threes > 0 ) {
                    if( Threes == count ) {
                        //All LEDs are low Green
                        //Go straight to checking lower positions
                        goImmediately = true;
                    }
                    else {
                        //Some LEDs are low Green
                        if( Eights > 0 || Nines > 0 ) {
                            //Board not flat
                            boardNotFlat = true;
                        }
                        else if( Sevens > 0 ) {
                            slideobj = {toptext: "Vrid det silverfärgade hjulet moturs", topimg: "blue-anti.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-2.png", help: "help/silverwheelhelp.html" };
                        }
                        else
                        {
                            //Go straight to checking lower positions
                            goImmediately = true;
                        }
                    }
                }
                else if ( Fours > 0 ) {
                    if( Fours == count ) {
                        //All LEDs are high Green
                        slideobj = {toptext: "Vrid det silverfärgade hjulet moturs", topimg: "blue-anti.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-3.png", help: "help/silverwheelhelp.html" };
                    }
                    else {
                        //Some LEDs are high Green
                        if( Eights > 0 || Nines > 0 ) {
                            slideobj = {toptext: "Vrid det silverfärgade hjulet moturs", topimg: "blue-anti.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-2.png", help: "help/silverwheelhelp.html" };
                        }
                        else
                        {
                            slideobj = {toptext: "Vrid det silverfärgade hjulet moturs", topimg: "blue-anti.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-3.png", help: "help/silverwheelhelp.html" };
                        }
                    }
                }
                else {
                    //Must be all 5s or above
                    slideobj = {toptext: "Vrid det silverfärgade hjulet moturs", topimg: "blue-anti.png", lowertext: "tills LED-indikatorerna visar följande:", lowerimg: "led-3.png", help: "help/silverwheelhelp.html" };
                }

                if( slideobj != null )
                {
                    pos = findFirstPos(collRes);
                }

                if( boardNotFlat ) {
                    destination = "notflat.html";
                    goImmediately = true;
                }
                else {
                    destination = "leds.html?pos=" + midCheckSeq[0] + "&mode=mcheck&oldpos=" + pos;
                }
                break;
        }
    }

    if( slideobj != null )
    {
        updatePage(slideobj);
    }

    if( goImmediately )
    {
        window.location.href = destination;
    }
}

function collateResults()
{
    var ret = [];
    for( var j = 0; j <= 9; j++ ) {
        var ledcount = 0;
        for( var i = 0; i < results.length; i++ ) {
            if( results[i].indexOf(j.toString()) > -1 ) {
                ledcount++;
            }
        }
        ret.push( ledcount );
    }
    return ret;
}

function findFirstPos(colres) {
    var newpos = 0;
    for( var i = 0; i < colres.length; i++ )
    {
        if( colres[i] > 0 )
        {
            //First non-zero colour, find its first position
            switch (mode)
            {
                case "ucheck":
                    for(var j = 0; j < upperCheckSeq.length; j++ ) {
                        var ledstr = i.toString();
                        if( results[j].indexOf( ledstr ) > -1 ) {
                            newpos = upperCheckSeq[j];
                            positionTarget(newpos);
                            break;
                        }
                    }
                    break;

                case "mcheck":
                    for(var k = 0; k < midCheckSeq.length; k++ ) {
                        var mledstr = i.toString();
                        if( results[k].indexOf( mledstr ) > -1 ) {
                            newpos = midCheckSeq[k];
                            positionTarget(newpos);
                            break;
                        }
                    }
                    break;

                case "lcheck":
                    for(var m = 0; m < lowerCheckSeq.length; m++ ) {
                        var lledstr = i.toString();
                        if( results[m].indexOf( lledstr ) > -1 ) {
                            newpos = lowerCheckSeq[m];
                            positionTarget(newpos);
                            break;
                        }
                    }
                    break;
            }
            break;
        }
    }
    return newpos;
}

$('#nextbutton').click(function () {
    console.log("Next Click: " + destination);
    window.location.href = destination;
});

$('#backbutton').click(function () {
    console.log("Prev Click");
    window.history.back();
});

function buildDestination(slidedata) {
    var dest = "";
    switch( slidedata.next )
    {
        case "leds":
            if( slidedata.nextpos != "C" ) {
                dest = "leds.html?pos=" + slidedata.nextpos + "&oldpos=" + pos.toString();
            }
            else {
                //Go to Check mode
                dest = "leds.html?pos=" + upperCheckSeq[0] + "&mode=ucheck&oldpos=" + pos.toString();
            }
            break;

        case "action":
            dest = "action.html?pos=" + slidedata.nextpos + "&ref=" + slidedata.nextref + "&oldpos=" + pos.toString();
            break;
    }
    return dest;
}

$('#helpbutton').click(function() {
    $('#modalBackground').toggle();
    $('#helpFrame').toggleClass("helpHidden");


    if(( mode != "setup" || slideIndex > -1 ) && !helpLoaded)
    {
        helpLoaded = true;
        var fileName;
        if( mode == "setup" ) {
            fileName = slideInfo[slideIndex].help;
        }
        else
        {
            fileName = slideobj.help;
        }

        if( fileName != null )
        {
            $.get(fileName, function(data) {
                $('#helpContents').html(data);

                $(document).on('click', '.helpQuestion', function(){
                    accordian( $(this) );
                });
            });
        }
    }
});
